// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.12.4
// source: quiz/quiz_svc.proto

package quiz

import (
	context "context"
	enrollment "gitlab.com/go-pro-capt/platzi-go/grpc-api/api/grpc/pb/enrollment"
	question "gitlab.com/go-pro-capt/platzi-go/grpc-api/api/grpc/pb/question"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// QuizServiceClient is the client API for QuizService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type QuizServiceClient interface {
	SetQuiz(ctx context.Context, in *Quiz, opts ...grpc.CallOption) (*SetQuizResponse, error)
	GetQuiz(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*Quiz, error)
	GetQuestionsByQuiz(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*question.SetQuestionPerQuizResponse, error)
	GetEnrolledStudentsByQuiz(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*enrollment.SetEnrolledStudentsResponse, error)
	ShowQuizResults(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*SetQuizResultsResponse, error)
}

type quizServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewQuizServiceClient(cc grpc.ClientConnInterface) QuizServiceClient {
	return &quizServiceClient{cc}
}

func (c *quizServiceClient) SetQuiz(ctx context.Context, in *Quiz, opts ...grpc.CallOption) (*SetQuizResponse, error) {
	out := new(SetQuizResponse)
	err := c.cc.Invoke(ctx, "/quiz.QuizService/SetQuiz", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *quizServiceClient) GetQuiz(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*Quiz, error) {
	out := new(Quiz)
	err := c.cc.Invoke(ctx, "/quiz.QuizService/GetQuiz", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *quizServiceClient) GetQuestionsByQuiz(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*question.SetQuestionPerQuizResponse, error) {
	out := new(question.SetQuestionPerQuizResponse)
	err := c.cc.Invoke(ctx, "/quiz.QuizService/GetQuestionsByQuiz", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *quizServiceClient) GetEnrolledStudentsByQuiz(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*enrollment.SetEnrolledStudentsResponse, error) {
	out := new(enrollment.SetEnrolledStudentsResponse)
	err := c.cc.Invoke(ctx, "/quiz.QuizService/GetEnrolledStudentsByQuiz", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *quizServiceClient) ShowQuizResults(ctx context.Context, in *GetQuizRequest, opts ...grpc.CallOption) (*SetQuizResultsResponse, error) {
	out := new(SetQuizResultsResponse)
	err := c.cc.Invoke(ctx, "/quiz.QuizService/ShowQuizResults", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// QuizServiceServer is the server API for QuizService service.
// All implementations must embed UnimplementedQuizServiceServer
// for forward compatibility
type QuizServiceServer interface {
	SetQuiz(context.Context, *Quiz) (*SetQuizResponse, error)
	GetQuiz(context.Context, *GetQuizRequest) (*Quiz, error)
	GetQuestionsByQuiz(context.Context, *GetQuizRequest) (*question.SetQuestionPerQuizResponse, error)
	GetEnrolledStudentsByQuiz(context.Context, *GetQuizRequest) (*enrollment.SetEnrolledStudentsResponse, error)
	ShowQuizResults(context.Context, *GetQuizRequest) (*SetQuizResultsResponse, error)
	mustEmbedUnimplementedQuizServiceServer()
}

// UnimplementedQuizServiceServer must be embedded to have forward compatible implementations.
type UnimplementedQuizServiceServer struct {
}

func (UnimplementedQuizServiceServer) SetQuiz(context.Context, *Quiz) (*SetQuizResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetQuiz not implemented")
}
func (UnimplementedQuizServiceServer) GetQuiz(context.Context, *GetQuizRequest) (*Quiz, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetQuiz not implemented")
}
func (UnimplementedQuizServiceServer) GetQuestionsByQuiz(context.Context, *GetQuizRequest) (*question.SetQuestionPerQuizResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetQuestionsByQuiz not implemented")
}
func (UnimplementedQuizServiceServer) GetEnrolledStudentsByQuiz(context.Context, *GetQuizRequest) (*enrollment.SetEnrolledStudentsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetEnrolledStudentsByQuiz not implemented")
}
func (UnimplementedQuizServiceServer) ShowQuizResults(context.Context, *GetQuizRequest) (*SetQuizResultsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ShowQuizResults not implemented")
}
func (UnimplementedQuizServiceServer) mustEmbedUnimplementedQuizServiceServer() {}

// UnsafeQuizServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to QuizServiceServer will
// result in compilation errors.
type UnsafeQuizServiceServer interface {
	mustEmbedUnimplementedQuizServiceServer()
}

func RegisterQuizServiceServer(s grpc.ServiceRegistrar, srv QuizServiceServer) {
	s.RegisterService(&QuizService_ServiceDesc, srv)
}

func _QuizService_SetQuiz_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Quiz)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QuizServiceServer).SetQuiz(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/quiz.QuizService/SetQuiz",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QuizServiceServer).SetQuiz(ctx, req.(*Quiz))
	}
	return interceptor(ctx, in, info, handler)
}

func _QuizService_GetQuiz_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetQuizRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QuizServiceServer).GetQuiz(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/quiz.QuizService/GetQuiz",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QuizServiceServer).GetQuiz(ctx, req.(*GetQuizRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _QuizService_GetQuestionsByQuiz_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetQuizRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QuizServiceServer).GetQuestionsByQuiz(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/quiz.QuizService/GetQuestionsByQuiz",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QuizServiceServer).GetQuestionsByQuiz(ctx, req.(*GetQuizRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _QuizService_GetEnrolledStudentsByQuiz_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetQuizRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QuizServiceServer).GetEnrolledStudentsByQuiz(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/quiz.QuizService/GetEnrolledStudentsByQuiz",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QuizServiceServer).GetEnrolledStudentsByQuiz(ctx, req.(*GetQuizRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _QuizService_ShowQuizResults_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetQuizRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(QuizServiceServer).ShowQuizResults(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/quiz.QuizService/ShowQuizResults",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(QuizServiceServer).ShowQuizResults(ctx, req.(*GetQuizRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// QuizService_ServiceDesc is the grpc.ServiceDesc for QuizService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var QuizService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "quiz.QuizService",
	HandlerType: (*QuizServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SetQuiz",
			Handler:    _QuizService_SetQuiz_Handler,
		},
		{
			MethodName: "GetQuiz",
			Handler:    _QuizService_GetQuiz_Handler,
		},
		{
			MethodName: "GetQuestionsByQuiz",
			Handler:    _QuizService_GetQuestionsByQuiz_Handler,
		},
		{
			MethodName: "GetEnrolledStudentsByQuiz",
			Handler:    _QuizService_GetEnrolledStudentsByQuiz_Handler,
		},
		{
			MethodName: "ShowQuizResults",
			Handler:    _QuizService_ShowQuizResults_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "quiz/quiz_svc.proto",
}
